<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Fornitore;
use App\DataTables\FornitoreDataTable;
use App\DataTables\FornitoreDataTableEditor;
use Illuminate\Support\Facades\Auth;

class FornitoreController extends Controller
{
    public static $permission_group = "Fornitori";
    public static $permissions = [
        'view-fornitore' => 'Vedi',
        'create-fornitore' => 'Crea',
        'edit-fornitore' => 'Modifica',
        'delete-fornitore' => 'Elimina',
    ];
    
    public static function middleware(): array
    {
        return [
            new Middleware('permission:view-fornitore', only: ['index', 'show']),
            new Middleware('permission:create-fornitore|edit-fornitore|delete-fornitore', only: ['store', 'update', 'destroy']),
        ];
    }
    
    public function index(FornitoreDataTable $dataTable)
    {
        $dataTable->attivita_id = session()->get('attivita_attuale');
        return $dataTable->render('fornitore.index');
    }
    
    public function store(FornitoreDataTableEditor $editor)
    {
        $request = request();
        $input = $request->all();
        if($request->has('action')){
            switch($input['action']){
                case 'create':
                    if(!Auth::user()->can('create-fornitore')) return;
                    break;
                case 'edit':
                    if(!Auth::user()->can('edit-fornitore')) return;
                    break;
                case 'remove':
                    if(!Auth::user()->can('delete-fornitore')) return;
                    break;
            }
        }
        return $editor->process($request);
    }

    public function show_modal(Request $request)
    {
        $fornitore = Fornitore::find($request->get('fornitore_id'));
        if(!$fornitore) return redirect()->route('fornitore.index')->with('error', 'Fornitore non trovato');
        if(!Auth::user()->can('view-fornitore')) return abort(403, 'Non hai permesso di vedere questo fornitore');
        return view('fornitore.show_modal', ['fornitore' => $fornitore]);
    }

    public function show(Request $request)
    {
        $fornitore = Fornitore::find($request->get('fornitore_id'));
        if(!$fornitore) return redirect()->route('fornitore.index')->with('error', 'Fornitore non trovato');
        if(!Auth::user()->can('view-fornitore')) return abort(403, 'Non hai permesso di vedere questo fornitore');
        return view('fornitore.show', ['fornitore' => $fornitore]);
    }
}
